Bug 162716 - depmod fails during installation of kernel (most likley i2c-mpc related)
depmod fails during installation of kernel (most likley i2c-mpc related)
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: module-init-tools (Show other bugs)
rawhide
powerpc Linux
medium Severity medium
: ---
: ---
Assigned To: David Woodhouse
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2005-07-07 19:13 EDT by Frank Arnold
Modified: 2007-11-30 17:11 EST (History)
5 users (show)

See Also:
Fixed In Version: 3.2-0.pre7.2
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-07-22 17:14:29 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Frank Arnold 2005-07-07 19:13:17 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux ppc; de-DE; rv:1.7.8) Gecko/20050623 Fedora/1.0.4-5 Firefox/1.0.4

Description of problem:
System is a Powerbook G4 1,67GHz (Powerbook5,6):

Since kernel-2.6.12-1.1411_FC5 I'm not able to install new kernels from rawhide.
Last working version was 1.1400_FC5. It fails during depmod in the post script. 

Version-Release number of selected component (if applicable):
kernel-2.6.12-1.1411_FC5.ppc

How reproducible:
Always

Steps to Reproduce:
Install 2.6.12-1.1411_FC5 or newer kernel package on ppc32. Output:
---
[root]# rpm -ivh kernel-2.6.12-1.1422_FC5.ppc.rpm
Preparing...                ########################################### [100%]
   1:kernel                 ########################################### [100%]
WARNING: Couldn't find symtab and strtab in module /lib/modules/2.6.12-1.1422_FC5/kernel/drivers/i2c/busses/i2c-mpc.ko
/sbin/new-kernel-pkg: line 227: 31924 Segmentation fault      depmod -ae -F /boot/System.map-$version $version
No dep file found for kernel 2.6.12-1.1422_FC5
mkinitrd failed
error: %post(kernel-2.6.12-1.1422_FC5.ppc) scriptlet failed, exit status 1
---



Actual Results:  Installation is not complete. 

Expected Results:  A working kernel installation.

Additional info:

Have a look at the size of this driver. In 1400_FC5 it's about 9416 bytes, in 1422_FC5 only 1268 bytes. Other drivers are similar in their sizes.

I removed the module i2c-mpc.ko and started the following command manually, which doesn't work before (same error message as above):
---
[root]# /sbin/new-kernel-pkg --package kernel --mkinitrd --depmod --install 2.6.12-1.1422_FC5
---
No more error messages.
Comment 1 Dave Jones 2005-07-07 20:02:22 EDT
There's actually two bugs here.

1. What happened to that driver
2. depmod shouldn't segfault no matter what.

dwmw2, can you reproduce this on any of your ppc's ?
Comment 2 David Woodhouse 2005-07-08 03:42:14 EDT
Never seen it. Please install debuginfo for depmod and reproduce the SEGV in gdb.

Show the backtrace and check the md5sum of the module it was processing at the time.
Comment 3 Frank Arnold 2005-07-08 11:53:57 EDT
Installed module-init-tools-debuginfo-3.1-3. GDB output:
---
Starting program: /sbin/depmod -ae -F /boot/System.map-2.6.12-1.1422_FC5
2.6.12-1.1422_FC5
WARNING: Couldn't find symtab and strtab in module
/lib/modules/2.6.12-1.1422_FC5/kernel/drivers/i2c/busses/i2c-mpc.ko

Program received signal SIGSEGV, Segmentation fault.
has_dep_loop (module=0x11cf6f38, prev=Variable "prev" is not available.
) at depmod.c:389
389                     if (has_dep_loop(module->deps[i], &traverse))
(gdb) bt
#0  has_dep_loop (module=0x11cf6f38, prev=Variable "prev" is not available.
) at depmod.c:389
#1  0x100027bc in output_deps (modules=0x11e7df78, out=0x1205ae10)
    at depmod.c:430
#2  0x10002e6c in main (argc=Variable "argc" is not available.
) at depmod.c:862
#3  0x28000442 in ?? ()
#4  0x0fe8b84c in generic_start_main () from /lib/libc.so.6
#5  0x0fe8b9e4 in __libc_start_main () from /lib/libc.so.6
#6  0x0fe8b9e4 in __libc_start_main () from /lib/libc.so.6
Previous frame inner to this frame (corrupt stack?)
(gdb)
---

Checked entire kernel installation and module-init-tools with 
rpm -Vv kernel-2.6.12-1.1422_FC5
rpm -Vv module-init-tools-3.1-3
Everything ok.
Comment 4 Frank Arnold 2005-07-15 02:46:54 EDT
segfault of depmod is gone after update to module-init-tools-3.2-0.pre7.1

With kernel-2.6.12-1.1422_FC5 I still get this warning:
WARNING: Couldn't find symtab and strtab in module
/lib/modules/2.6.12-1.1432_FC5/kernel/drivers/i2c/busses/i2c-mpc.ko

And with kernel-2.6.12-1.1432_FC5 an additional one:
WARNING: /lib/modules/2.6.12-1.1432_FC5/kernel/net/tux/tux.ko needs unknown
symbol __tcp_push_pending_frames
Comment 5 Dan Carpenter 2005-07-15 04:28:04 EDT
About Comment #4:  See bug 163183
Comment 6 Frank Arnold 2005-07-16 04:12:07 EDT
Ok. tux is fixed with 1.1433.

The patch wich causing problems with i2c-mpc:
http://lkml.org/lkml/2005/6/22/357

I have no clue about kernel hacking but this patch removes all occurences of
module_init and module_exit. I think there was accidentally to much removed
(perhaps the CONFIG_FSL_OCP case).
Comment 7 Frank Arnold 2005-07-16 04:22:44 EDT
I should read twice... Certainly the `else' case shouldn't be removed. Sorry for
spam.
Comment 8 Paul Nasrat 2005-07-22 10:45:24 EDT
This is causing rawhide installs to be broken for ppc:

WARNING: Couldn't find symtab and strtab in module
/tmp/updboot.kernel.1288/ppc/lib/modules/2.6.12-1.1435_FC5/kernel/drivers/i2c/busses/i2c-mpc.ko
/mnt/redhat/nightly/rawhide-20050722/ppc/buildinstall.tree.25030/mk-images: line
178:  4249 Segmentation fault   
Comment 9 Frank Arnold 2005-07-22 11:13:55 EDT
Update on this issue:

Found out that a fix for i2c-mpc is under way. See
http://lkml.org/lkml/2005/7/14/308.

Regarding the depmod problem I was a bit too optimistic.
module-init-tools-3.2-0.pre7.1 doesn't fix this. Instead the segfault
disappeared with 2.6.12-1.1433_FC5 for some reason and came back with the recent
2.6.12-1.1435_FC5.
Comment 10 Bill Nottingham 2005-07-22 17:14:29 EDT
Crash fixed in module-init-tools-3.1-4/3.2-0.pre7.2.

Note You need to log in before you can comment on or make changes to this bug.